//***************************************** Forme() ******************************
class Forme {
    PShape    pont;
    boolean   one_shot_calcul      = true;
    float     longueur_forme       = 0F;
    int       nb_points            = 0;
    int       nb_points1           = 0;
    int       nb_points2           = 0;
    int       nb_points3           = 0;
    float     pas1                 = 0F;
    float     pas2                 = 0F;
    float     pas3                 = 0F;
    int       courbe               = 0;
    int       c_voie_pont          = 0;
    int       l_voie_pont          = 0;
    String    ID_zone              = "";
    //----------------------- variables venant du pavé ------------------------------------------------
    int       elongation           = 1;
    int       orientation          = 1;
    int       decalage             = 0;
    int       longueur_voie        = 0;
    int       hauteur_voie         = 0;
    int       deformation          = 0;
    float     retrait0             = 0F;
    float     retrait1             = 0F;
    boolean   cible[]              = new boolean[2];
    boolean   cible_visible[]      = new boolean[2];
    boolean   butoir[]             = new boolean[2];
    boolean   appareil_de_voie     = false;
    //----------------------- variables du connecteur -------------------------------------------------
    PVector   base[]               = new PVector[20];
    PVector   connecteur_absolu0   = new PVector(0, 0, 0);
    PVector   connecteur_absolu1   = new PVector(0, 0, 0);

    ArrayList<PVector> points         = new ArrayList<PVector>();                                                            //  liste de toutes les points de la forme. calculee une seule fois
    ArrayList<PVector> points_absolus = new ArrayList<PVector>();                                                            //  liste de toutes les points de la forme. calculee une seule fois

    Forme() {
        //pont = createShape();
    }  //  constructeur

    //--------------------------------------- pave_vers_forme() ------------------------------------------------
    void pave_vers_forme(int _elongation, int _orientation, int _decalage, boolean _appareil_de_voie,
                      boolean _butoir0, boolean _butoir1, boolean _cible0, boolean _cible1, boolean _cible_visible0, boolean _cible_visible1) {
        elongation       = _elongation;
        orientation      = _orientation;
        decalage         = _decalage;
        appareil_de_voie = _appareil_de_voie;
        butoir[0]        = _butoir0;
        butoir[1]        = _butoir1;
        cible[0]         = _cible0;
        cible[1]         = _cible1;
        cible_visible[0] = _cible_visible0;
        cible_visible[1] = _cible_visible1;
        modification(elongation, orientation, decalage);
        description_forme();
        calcule_points();
    }
    //------------------------------------- CibleOuest() ----------------------------------------------------
    void CibleOuest(float _x1, float _y1, float _rallonge, int _cote) {                                                                                                       //  on ne dessine une cible que si c'est une cible et que ce n'est pas un appareil de voie
        if (butoir[_cote]) {
            base[4+5*_cote] = new PVector(_x1-RAIL,            _y1);
            base[5+5*_cote] = new PVector(_x1-RAIL-MAILLE/6F,  _y1);
        } else {
            base[2+5*_cote] = new PVector(_x1+2F*MAILLE/3F,    _y1-_rallonge);
            base[3+5*_cote] = new PVector(base[2+5*_cote].x,                                
                                          base[2+5*_cote].y+MAILLE/2F-(MAILLE/3F+EPAISSEUR_MAT/4F)/2F+_rallonge);
            base[4+5*_cote] = new PVector(base[3+5*_cote].x-2F*MAILLE/3F+MAILLE/3F+RETRAIT, 
                                          base[3+5*_cote].y);
            base[5+5*_cote] = new PVector(base[4+5*_cote].x-MAILLE/3F, base[4+5*_cote].y);
        }
    }
    //------------------------------------- SignalOuest() ----------------------------------------------------
    void SignalOuest(float _x1, float _y1, boolean _cible, float _rallonge) {
        if (_cible) {                                                                                                        //  on ne dessine une cible que si c'est une cible et que ce n'est pas un appareil de voie
            CibleOuest(_x1, _y1, _rallonge, 0);
            base[6] = new PVector((base[4].x+base[5].x)/2F, (base[4].y+base[5].y)/2F, 0);
        }
    }
    //------------------------------------- SignalEst() ----------------------------------------------------
    void SignalEst(float _x1, float _y1, boolean _cible, float _rallonge, int _rotation) {
        if (_cible) {                                                                                                        //  on ne dessine une cible que si c'est une cible et que ce n'est pas un appareil de voie
            CibleOuest(_x1, _y1, _rallonge, 1);
            rotation_base(_rotation, 7, 12);
            base[11] = new PVector((base[9].x+base[10].x)/2F, (base[9].y+base[10].y)/2F, 0);
        }
    }
    //--------------------------------CibleNordOuest() ---------------------------------------------------------
    void CibleNordOuest(float _x1, float _y1, float _rallonge, int _cote) {
        if (butoir[_cote]) {
            base[4+5*_cote] = new PVector(_x1-RAIL/sqrt(2F),                     _y1-RAIL/sqrt(2F));
            base[5+5*_cote] = new PVector(_x1-RAIL/sqrt(2F)-MAILLE/6F/sqrt(2F),  _y1-RAIL/sqrt(2F)-MAILLE/6F/sqrt(2F));
        } else {
            base[2+5*_cote] = new PVector(_x1+MAILLE/2F+_rallonge/sqrt(2F),      _y1+MAILLE/2F-_rallonge/sqrt(2F));
            base[3+5*_cote] = new PVector(base[2+5*_cote].x-(MAILLE/2F-(MAILLE/3F-EPAISSEUR_MAT)/2F+_rallonge)/sqrt(2F),
                                          base[2+5*_cote].y+(MAILLE/2F-(MAILLE/3F-EPAISSEUR_MAT)/2F+_rallonge)/sqrt(2F));
            base[4+5*_cote] = new PVector(base[3+5*_cote].x-(sqrt(2F)*MAILLE/2F-RETRAIT-MAILLE/3F)/sqrt(2F),
                                          base[3+5*_cote].y-(sqrt(2F)*MAILLE/2F-RETRAIT-MAILLE/3F)/sqrt(2F));
            base[5+5*_cote] = new PVector(base[4+5*_cote].x-MAILLE/3F/sqrt(2F), base[4+5*_cote].y-MAILLE/3F/sqrt(2F));
        }
    }
    //-------------------------------- SignalNordOuest() ---------------------------------------------------------
    void SignalNordOuest(float _x1, float _y1, boolean _cible, float _rallonge) {
        if (_cible) {
            CibleNordOuest(_x1, _y1, _rallonge, 0);
            base[6] = new PVector((base[4].x+base[5].x)/2F, (base[4].y+base[5].y)/2F, 0);
        }
    }
    //-------------------------------- SignalNordEst() ---------------------------------------------------------
    void SignalNordEst(float _x1, float _y1, boolean _cible, float _rallonge, int _rotation) {
        if (_cible) {
            CibleNordOuest(_x1, _y1, _rallonge, 1);
            rotation_base(_rotation, 7, 12);
            base[11] = new PVector((base[9].x+base[10].x)/2F, (base[9].y+base[10].y)/2F, 0);
        }
    }
    //-------------------------------------- rotation points -------------------------------
    void rotation_base(int _formule, int _debut, int _fin) {
        for (int i = _debut; i < _fin; i++) {
            if (base[i] != null) {
                base[i].rotate(_formule*HALF_PI);
                switch (_formule) {                                                                                                  //  la rotation se fait autour du point 0,0. On doit donc corriger pour recentrer le pavé
                    case 0:
                        break;
                    case 1:
                        base[i] = base[i].add(MAILLE, 0);
                       break;
                    case 2 :
                        base[i] = base[i].add(MAILLE, MAILLE);
                        break;
                    case 3:
                        base[i] = base[i].add(0,      MAILLE);
                        break;
                }
            }
        }
        nb_points1 = 0;
        nb_points2 = 0;
        nb_points3 = 0;
        points.clear();
    }
    //--------------------------------calcule_point_droite() ----------------------------------------------
    void calcule_points_droite(PVector _origine, PVector _extremite) {
        float longueur  = PVector.dist(_origine, _extremite);
        int   nb_point  = int(0.5F+longueur/PAS);
        float pas       = longueur/nb_point;
        float pas_x = 0;
        float pas_y = 0;
        pas_x = pas*(_extremite.x-_origine.x)/longueur;
        pas_y = pas*(_extremite.y-_origine.y)/longueur;
        for (int i = 0; i < nb_point; i++) {
            points.add(new PVector(_origine.x+(i+0.5F)*pas_x, _origine.y+(i+0.5F)*pas_y));
            points_absolus.add(new PVector(0, 0, 0));
        }
        nb_points = nb_point;
    }
    //--------------------------------calcule_point_arc() ----------------------------------------------
    void calcule_points_arc(float _rayon, PVector b0, PVector b1, PVector b2, PVector b3) {
        float longueur  = _rayon;
        int   nb_point  = int(0.5F+longueur/PAS);
        float pas       = longueur/nb_point;
        for (int i = 0; i < nb_point; i++) {
            float t = (i+0.5F)*pas/longueur;
            float x = bezierPoint(b0.x, b1.x, b2.x, b3.x, t);
            float y = bezierPoint(b0.y, b1.y, b2.y, b3.y, t);
            points.add(new PVector(x, y, t));
            points_absolus.add(new PVector(0, 0, 0));
        }
        nb_points = nb_point;
    }
    //------------------------------------- points_absolus() -------------------------------------------    
    void points_absolus(int _c, int _l, int _index) {                                                                       //  ces formules permettent de calculer les coordonnées ABSOLUES...        
        float X = bordure_x+(points.get(_index).x+(_c+c_min+niveau/2F)*MAILLE)*zoom_x;
        float Y = bordure_y+(points.get(_index).y+(_l+l_min+niveau/2F)*MAILLE)*zoom_y;
        float Z = points.get(_index).z;
        points_absolus.set(_index, new PVector(X, Y, Z)); 
        if (_l > L_MAX) {
            points_absolus.set(_index, points_absolus.get(_index).add(-MAILLE*zoom_x/2F, -MAILLE*zoom_y*(L_MAX+0.5F), 0));
        }
    }    
    //------------------------------------- dessine_cibles() ----------------------------------------------------
    void dessine_cibles(int _cote) {
        if (cible_visible[_cote]) {
            stroke(NOIR);
            strokeCap(SQUARE);       
            strokeWeight(EPAISSEUR_MAT);
            if (base[2+5*_cote] != null) {
                line(base[2+5*_cote].x, base[2+5*_cote].y,   base[3+5*_cote].x,  base[3+5*_cote].y);
                line(base[3+5*_cote].x, base[3+5*_cote].y,   base[4+5*_cote].x,  base[4+5*_cote].y);
            }
            strokeWeight(2F*TAILLE_FEU+0.02);
            line(base[4+5*_cote].x, base[4+5*_cote].y,   base[5+5*_cote].x,  base[5+5*_cote].y);
            noStroke();
        }
    }
    //-------------------------------------- dessine_feux() -----------------------------------------------------
    void dessine_feux(int _couleur_feu, boolean _feu_clignotant, boolean _feu_noir, int _cote){
        int couleur_feu;
        if (_feu_clignotant) {
            if (cliFeux) {
                couleur_feu = ARDOISE;
            } else {
                couleur_feu = _couleur_feu;
            }
        } else {
            couleur_feu = _couleur_feu;
        }
        if (_feu_noir) {
            couleur_feu = NOIR;
            strokeWeight(3);
        } else {
            strokeWeight(1);
        }
        stroke(couleur_feu);
        fill(couleur_feu);
        ellipse(base[6+5*_cote].x*zoom_x, base[6+5*_cote].y*zoom_y, TAILLE_FEU*zoom_x, TAILLE_FEU*zoom_y);
    }
    //-------------------------------- dessine_forme() -----------------------------------------------------
    void dessine_forme(int _couleur, float _largeur) {
        noFill();
        stroke(_couleur);
        strokeWeight(_largeur);
        strokeCap(SQUARE);
        if (base[12] != null) {
            switch (courbe) {
                case 0:
                    line(base[12].x, base[12].y, base[13].x, base[13].y);
                    break;
                case 1:
                    bezier(base[12].x, base[12].y, base[13].x, base[13].y, base[14].x, base[14].y, base[15].x, base[15].y);
                    break;
                case 2:
                    bezier(base[12].x, base[12].y, base[13].x, base[13].y, base[14].x, base[14].y, base[15].x, base[15].y);
                    line(base[15].x, base[15].y, base[16].x, base[16].y);
                    break;
                case 3:
                    line(base[12].x, base[12].y, base[13].x, base[13].y);
                    bezier(base[13].x, base[13].y, base[14].x, base[14].y, base[15].x, base[15].y, base[16].x, base[16].y);
                    break;
                case 4:
                    bezier(base[12].x, base[12].y, base[13].x, base[13].y, base[14].x, base[14].y, base[15].x, base[15].y);
                    line(base[15].x, base[15].y, base[16].x, base[16].y);
                    bezier(base[16].x, base[16].y, base[17].x, base[17].y, base[18].x, base[18].y, base[19].x, base[19].y);
                    break;
                case 5:
                    line(base[12].x, base[12].y, base[14].x, base[14].y);
                    bezier(base[14].x, base[14].y, base[15].x, base[15].y, base[16].x, base[16].y, base[17].x, base[17].y);
                    line(base[17].x, base[17].y, base[13].x, base[13].y);
                    break;
                case 6:
                    line(base[12].x, base[12].y, base[13].x, base[13].y);
                    stroke(NOIR);
                    strokeWeight(3F*RAIL);
                    line(base[12].x, base[12].y, base[14].x, base[14].y);
                    break;
            }
        }
        strokeWeight(1);
        noStroke();
        noFill();
    }
    //-------------------------------------- dessine points() --------------------------------------------------
    void dessine_points() {
        noStroke();
        if (affiche_points) {
            if (nb_points1 > 3) {
                fill(ROUGE);
                dessine_point(points.get(0), PAS/2F);
                fill(JAUNE);
                for (int i = 1; i < nb_points1; i++) {
                    dessine_point(points.get(i), PAS/2F);
                }
            }
            if (nb_points2 > 0) {
                fill(ROUGE);
                dessine_point(points.get(nb_points1), PAS/2F);
                fill(VERT);
                for (int i = 1; i < nb_points2; i++) {
                    dessine_point(points.get(i+nb_points1), PAS/2F);
                }
            }
            if (nb_points3 > 0) {
                fill(ROUGE);
                dessine_point(points.get(nb_points1+nb_points2), PAS/2F);
                fill(AQUA);
                for (int i = 1; i < nb_points3; i++) {
                    dessine_point(points.get(i+nb_points1+nb_points2), PAS/2F);
                }
            }
        }
    }
    //------------------------------------ dessine_point() --------------------------------------------------
    void dessine_point(PVector _point, float _pas) {
        ellipse(_point.x, _point.y, _pas, _pas);
    }
    //------------------------------------ dessine_nom_zone() --------------------------------------------------
    void dessine_nom_zone() {
        if (affiche_points && points.size() != 0) {
            fill(ROUGE);
            rectMode(CENTER);
            textSize(4);
            text(ID_zone, points.get(int((nb_points1+nb_points2+nb_points3)/2F)).x, 
                          points.get(int((nb_points1+nb_points2+nb_points3)/2F)).y);
            rectMode(CORNER);
        }
    }
    //------------------------------------- connecteurs_absolus() -------------------------------------------    
    void connecteurs_absolus (int _c, int _l) {                                                                              //  ces formules permettent de calculer les coordonnées ABSOLUES...
        connecteur_absolu0.x = bordure_x+(base[0].x+(_c+c_min+niveau/2F)*MAILLE)*zoom_x;                                 //  ...des connecteurs à partir des coordonnées RELATIVES liees aux objets.
        connecteur_absolu0.y = bordure_y+(base[0].y+(_l+l_min+niveau/2F)*MAILLE)*zoom_y;                                 //  c'est necessaire pour abouter les pavés, aussi bien pour un niveau donne...
        connecteur_absolu1.x = bordure_x+(base[1].x+(_c+c_min+niveau/2F)*MAILLE)*zoom_x;                                 //  ...que pour les zones à cheval sur deux niveaux
        connecteur_absolu1.y = bordure_y+(base[1].y+(_l+l_min+niveau/2F)*MAILLE)*zoom_y;
        if (_l > L_MAX) {
            connecteur_absolu0.x = connecteur_absolu0.x-MAILLE*zoom_x/2F;
            connecteur_absolu0.y = connecteur_absolu0.y-MAILLE*zoom_y*(L_MAX+0.5F);
            connecteur_absolu1.x = connecteur_absolu1.x-MAILLE*zoom_x/2F;
            connecteur_absolu1.y = connecteur_absolu1.y-MAILLE*zoom_y*(L_MAX+0.5F);
        }
    }
    //--------------------------------modification_flexible() ------------------------------------------
    void modification_flexible(int _orientation, int _longueur_voie, int _hauteur_voie, int _deformation,
                               boolean _appareil_de_voie, boolean _butoir0, boolean _butoir1,
                               boolean _cible0, boolean _cible1, boolean _cible_visible0, boolean _cible_visible1) {
        orientation      = _orientation;
        longueur_voie    = _longueur_voie;
        hauteur_voie     = _hauteur_voie;
        deformation      = _deformation;
        appareil_de_voie = _appareil_de_voie;
        butoir[0]        = _butoir0;
        butoir[1]        = _butoir1;
        cible[0]         = _cible0;
        cible[1]         = _cible1;
        cible_visible[0] = _cible_visible0;
        cible_visible[1] = _cible_visible1;
        description_forme();
        points.clear();
        calcule_points_flexible();
    }
    //--------------------------------------- calcule_flexible() ------------------------------------------------
    void calcule_flexible(float _debut, float _retrait0, float _retrait1, int _indice) {
        base[0]  = new PVector(0,                                     _debut);
        base[1]  = new PVector(X4_x,                                  X4_y);
        //---------- arc ---------------------        
        base[12] = new PVector(base[0].x+max(0, retrait0)*_retrait0,  base[0].y+max(0, retrait0)*_retrait1);
        base[13] = new PVector(P3_x,                                  P3_y);
        base[14] = new PVector(P3g_x,                                 P3g_y);
        //---------- droite ------------------
        base[15] = new PVector(T3_x,                                  T3_y);
        base[16] = new PVector(T4_x,                                  T4_y);
        //---------- arc ---------------------
        base[17] = new PVector(P4d_x,                                 P4d_y);
        base[18] = new PVector(P4_x,                                  P4_y);
        base[19] = new PVector(base[1].x-max(0, retrait1)*_retrait0,  base[1].y-max(0, retrait1)*_retrait1);
        SignalOuest(           base[0].x,                             base[0].y,         cible[0], RAIL/2F);
        SignalEst(            -base[1].x+MAILLE,                     -base[1].y+MAILLE,  cible[1], RAIL/2F, 2);
        rotation_base(((orientation-1) % 8)/2, 0, 20);
    }
    //--------------------------------------- calcule_points_flexible() -------------------------------------------
    void calcule_points_flexible() {
        calcule_points_arc(R3*alpha3, base[0], base[13], base[14], base[15]);
        nb_points1 = nb_points;
        calcule_points_droite(base[15], base[16]);
        nb_points2 = nb_points;
        calcule_points_arc(R4*alpha4, base[16], base[17], base[18], base[1]);
        nb_points3 = nb_points;
    }
    //--------------------------------------- methodes vides -------------------------------------------------------------------
    void modification(int _elongation, int _orientation, int _decalage) {}
    void modification_fosse(int _elongation) {}
    void modification_pont(int _elongation) {}
    void description_forme() {};
    void dessine_forme_fosse(int _couleur_fosse) {}
    void dessine_forme_pont_palette(int _couleur, int _c, int _l) {}
    void dessine_forme_pont(int _couleur) {}
    void modification_voie_pont(int _c_voie_pont, int _l_voie_pont, int _longueur_voie, int _hauteur_voie, int _deformation, int _ordre) {};
    void calcule_points() {};

    Forme copy()           { noStroke(); return null; }

}
//***************************************************************************************************************************************************************************
//**************************************************** Formes particulieres *************************************************************************************************
//***************************************************************************************************************************************************************************
class DroitOuestEst extends Forme {
    DroitOuestEst(int _decalage, int _elongation) {
        decalage   = _decalage;
        elongation = _elongation;
        courbe     = 0;
        description_forme();
    }
    //-------------------------------- description_forme() ------------------------------------------
    void description_forme() { // appelé par le constructeur et les changements de taille
        base[0]  = new PVector(0,                                   MAILLE/2F);
        base[1]  = new PVector(MAILLE*(elongation-1)/2F+MAILLE/2F,  MAILLE/2F);
        base[12] = new PVector(base[0].x+max(0, retrait0)*RETRAIT,  base[0].y);
        base[13] = new PVector(base[1].x-max(0, retrait1)*RETRAIT,  base[1].y);
        SignalOuest(           base[0].x,                           base[0].y,         cible[0], 0);
        SignalEst(            -base[1].x+MAILLE,                   -base[1].y+MAILLE,  cible[1], 0, 2);
        rotation_base(((2*decalage+orientation-1) % 8)/2, 0, 14);
    }
    //------------------------------- calcule_points() ----------------------------------
    void calcule_points() {
        calcule_points_droite(base[0], base[1]);
        nb_points1 = nb_points;
    }
    Forme copy() { return new DroitOuestEst(decalage, elongation); }
}
//***************************************************************************************************************************************************************************
class DroitNordOuestSudEst extends Forme {
    DroitNordOuestSudEst(int _decalage) {
        decalage   = _decalage;
        elongation = 2;
        courbe     = 0;
        description_forme();
    }
    //-------------------------------- description_forme() ------------------------------------------
    void description_forme() { // appelé par le constructeur et les changements de taille
        base[0]  = new PVector(0,                                        0);
        base[1]  = new PVector(MAILLE*(elongation-1)/2F+MAILLE/2F+0.1,   MAILLE*(elongation-1)/2F+MAILLE/2F+0.1);
        base[12] = new PVector(base[0].x+max(0, retrait0)*DIAG_RETRAIT,  base[0].y+max(0, retrait0)*DIAG_RETRAIT);
        base[13] = new PVector(base[1].x-max(0, retrait1)*DIAG_RETRAIT,  base[1].y-max(0, retrait1)*DIAG_RETRAIT);
        SignalNordOuest(       base[0].x,                                base[0].y,         cible[0], 0);
        SignalNordEst(        -base[1].x+MAILLE,                        -base[1].y+MAILLE,  cible[1], 0, 2);
        rotation_base(((2*decalage+orientation-2) % 8)/2, 0, 14);
    }
    //------------------------------- calcule_points() ----------------------------------
    void calcule_points() {
        calcule_points_droite(base[0], base[1]);
        nb_points1 = nb_points;
    }
    Forme copy() { return new DroitNordOuestSudEst(decalage); }
}
//***************************************************************************************************************************************************************************
class Butoir extends Forme {
    Butoir() {
        courbe = 0;
        description_forme();
    }
    //-------------------------------- description_forme() ------------------------------------------
    void description_forme() { // appelé par le constructeur et les changements de taille
        base[0]  = new PVector(0,     MAILLE/2F);
        base[1]  = new PVector(RAIL,  MAILLE/2F);
        base[12] = new PVector(0,     MAILLE/2F);
        base[13] = new PVector(RAIL,  MAILLE/2F);
        rotation_base(((orientation-1) % 8)/2, 0, 14);
    }
    Forme copy() { return new Butoir(); }
}
//***************************************************************************************************************************************************************************
class Butoir45 extends Forme {
    Butoir45() {
        courbe = 0;
        description_forme();
    }
    //-------------------------------- description_forme() ------------------------------------------
    void description_forme() { // appelé par le constructeur et les changements de taille
        base[0]  = new PVector(0,              0);
        base[1]  = new PVector(RAIL/sqrt(2F),  RAIL/sqrt(2F));
        base[12] = new PVector(0,              0);
        base[13] = new PVector(RAIL/sqrt(2F),  RAIL/sqrt(2F));
        rotation_base(((orientation-1) % 8)/2, 0, 14);
    }
    Forme copy() { return new Butoir45(); }
}
//***************************************************************************************************************************************************************************
class Arc45OuestNordEst extends Forme {
    Arc45OuestNordEst(int _decalage) {
        decalage = _decalage;
        courbe   = 1;
        description_forme();
    }
    //-------------------------------- description_forme() ------------------------------------------
    void description_forme() { // appelé par le constructeur et les changements de taille
        base[0]  = new PVector(0,                                     MAILLE/2F);
        base[1]  = new PVector(MAILLE,                                0);
        base[12] = new PVector(max(0, retrait0)*RETRAIT,              MAILLE/2F);
        base[13] = new PVector(0.3864485F*MAILLE,                     0.4725356F*MAILLE);
        base[14] = new PVector(0.7461594F*MAILLE,                     0.2926802F*MAILLE);
        base[15] = new PVector(MAILLE-max(0, retrait1)*DIAG_RETRAIT,  max(0, retrait1)*DIAG_RETRAIT);
        SignalOuest(           base[0].x,                             base[0].y, cible[0],  RAIL);
        SignalNordEst(        -base[1].x+MAILLE,                      base[1].y, cible[1], -RAIL, 1);
        rotation_base(((2*decalage+orientation-1) % 8)/2, 0, 16);
    }
    //------------------------------- calcule_points() ----------------------------------
    void calcule_points() {
        calcule_points_arc(1.460785*MAILLE*QUARTER_PI, base[0], base[13], base[14], base[1]);
        nb_points1 = nb_points;
    }
    Forme copy() { return new Arc45OuestNordEst(decalage); }
}
//***************************************************************************************************************************************************************************
class Arc45NordOuestEst extends Forme {
    Arc45NordOuestEst(int _decalage) {
        decalage = _decalage;
        courbe   = 1;
        description_forme();
    }
    //-------------------------------- description_forme() ------------------------------------------
    void description_forme() { // appelé par le constructeur et les changements de taille
        base[0]  = new PVector(0,                                0);
        base[1]  = new PVector(MAILLE,                           MAILLE/2F);
        base[12] = new PVector(max(0, retrait0)*DIAG_RETRAIT,    max(0, retrait0)*DIAG_RETRAIT);
        base[13] = new PVector(0.2538412F*MAILLE,                0.2926796F*MAILLE, 0);
        base[14] = new PVector(0.6135516F*MAILLE,                0.4722535F*MAILLE, 0);
        base[15] = new PVector(MAILLE-max(0, retrait1)*RETRAIT,  MAILLE/2F);
        SignalNordOuest(       base[0].x,                        base[0].y,        cible[0],  RAIL);
        SignalEst(            -base[1].x+MAILLE,                -base[1].y+MAILLE, cible[1], -RAIL, 2);
        rotation_base(((2*decalage+orientation-2) % 8)/2, 0, 16);
    }
    //------------------------------- calcule_points() ----------------------------------
    void calcule_points() {
        calcule_points_arc(1.460785*MAILLE*QUARTER_PI, base[0], base[13], base[14], base[1]);
        nb_points1 = nb_points;
    }
    Forme copy() { return new Arc45NordOuestEst(decalage); }
}
//***************************************************************************************************************************************************************************
class Arc90 extends Forme {
    float magic             = 0.551784F;
    int   elongation_locale = 0;
    float rayon             = 0;
    Arc90() {
        modification(1, 0, 0);
        descriptionArc90OuestSud();
    }
    //--------------------------------- modification() -----------------------------------------------
    void modification(int _elongation, int _orientation, int _decalage) {
        elongation        = _elongation;
        orientation       = _orientation;
        decalage          = _decalage;
        elongation_locale = int((elongation-1F)/3F)+1;
        rayon             = MAILLE*(elongation_locale-1)+MAILLE/2F;
        switch(elongation % 3) {
            case 0:
                courbe = 3;
                descriptionArc90OuestSudEst();
                calcule_pointsOSE();
                break;
            case 1:
                courbe = 1;
                descriptionArc90OuestSud();
                calcule_pointsOS();
                break;
            case 2:
                courbe = 2;
                descriptionArc90NordOuestSud();
                calcule_pointsNOS();
                break;
        }
    }
    //++++++++++++++++++++++++++++++++++ descriptionArc90OuestSudEst() +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    void descriptionArc90OuestSudEst() { // appele par le constructeur et les changements de taille
        base[0]  = new PVector(0,                         MAILLE/2F);
        base[1]  = new PVector(MAILLE*elongation_locale,  MAILLE*elongation_locale);
        //---------- droite ------------------
        base[12] = new PVector(max(0, retrait0)*RETRAIT,  MAILLE/2F);
        base[13] = new PVector(MAILLE/2F,                 MAILLE/2F);
        //---------- arc ---------------------
        base[14] = new PVector(MAILLE/2F+rayon*magic,     MAILLE/2F);
        base[15] = new PVector(MAILLE*elongation_locale,  MAILLE*elongation_locale-rayon*magic);
        base[16] = new PVector(MAILLE*elongation_locale,  MAILLE*elongation_locale);
        SignalOuest(           base[0].x,                 base[0].y,        cible[0],  0);
        SignalEst(            -base[1].x+MAILLE,          base[1].y,        cible[1],  0, 3);
        rotation_base(((orientation-1) % 8)/2, 0, 17);
    }
    //------------------------------- calcule_pointsOSE() ----------------------------------
    void calcule_pointsOSE() {
        calcule_points_droite(base[0], base[13]);
        nb_points1     = nb_points;
        calcule_points_arc(rayon*HALF_PI, base[13], base[14], base[15], base[16]);
        nb_points2     = nb_points;
    }
    //++++++++++++++++++++++++++++++++++ descriptionArc90OuestSud() +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    void descriptionArc90OuestSud() { // appele par le constructeur et les changements de taille
        base[0]  = new PVector(0,                                            MAILLE/2F);
        base[1]  = new PVector(rayon,                                        MAILLE*elongation_locale);
        //---------- arc ---------------------
        base[12] = new PVector(max(0, retrait0)*RETRAIT,                     MAILLE/2F);
        base[13] = new PVector(rayon*magic,                                  MAILLE/2F);
        base[14] = new PVector(rayon,                                        MAILLE*elongation_locale-rayon*magic);
        base[15] = new PVector(rayon,                                        MAILLE*elongation_locale-max(0, retrait1)*RETRAIT);
        SignalOuest(           base[0].x,                                    base[0].y,           cible[0],  0);
        SignalEst(             base[1].x+MAILLE/6F-2F*MAILLE*elongation/3F,  base[1].y-MAILLE/2F, cible[1],  0, 3);
        rotation_base(((orientation-1) % 8)/2, 0, 16);
    }
    //------------------------------- calcule_pointsOS() ----------------------------------
    void calcule_pointsOS() {
        calcule_points_arc(rayon*HALF_PI, base[0], base[13], base[14], base[1]);
        nb_points1 = nb_points;
    }
    //++++++++++++++++++++++++++++++++++ descriptionArc90NordOuestSud() ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    void descriptionArc90NordOuestSud() { // appele par le constructeur et les changements de taille
        base[0]  = new PVector(0,                                              0);
        base[1]  = new PVector(rayon,                                          MAILLE*elongation_locale);
        //---------- arc ---------------------
        base[12] = new PVector(max(0, retrait0)*RETRAIT,                       0);
        base[13] = new PVector(rayon*magic,                                    0);
        base[14] = new PVector(rayon,                                          MAILLE*elongation_locale-MAILLE/2F-rayon*magic);
        base[15] = new PVector(rayon,                                          MAILLE*elongation_locale-MAILLE/2F);
        //---------- droite ------------------
        base[16] = new PVector(rayon,                                          MAILLE*elongation_locale-max(0, retrait1)*RETRAIT);
        SignalOuest(           base[0].x,                                      base[0].y,           cible[0],  0);
        SignalEst(             base[1].x+5F*MAILLE/6F-2F*MAILLE*elongation/3F, base[1].y-MAILLE/2F, cible[1],  0, 3);
        rotation_base(((orientation-1) % 8)/2, 0, 17);
    }
    //------------------------------- calcule_pointsNOS() ----------------------------------
    void calcule_pointsNOS() {
        calcule_points_arc(rayon*HALF_PI, base[0], base[13], base[14], base[15]);
        nb_points1 = nb_points;
        calcule_points_droite(base[15], base[1]);
        nb_points2     = nb_points;
    }
    Forme copy() { return new Arc90(); }
}
//***************************************************************************************************************************************************************************
class Arc90NordOuestSudOuest extends Forme {
    float magic = 0.551784F;
    Arc90NordOuestSudOuest() {
        courbe = 1;
        description_forme();
    }
    //-------------------------------- modification() ----------------------------------------------
    void modification(int _elongation, int _orientation, int _decalage) {
        elongation        = _elongation;
        orientation       = _orientation;
        description_forme();
        calcule_points();
    }
    //-------------------------------- description_forme() ------------------------------------------
    void description_forme() { // appele par le constructeur et les changements de taille
        base[0]  = new PVector(0,                                0);
        base[1]  = new PVector(0,                                MAILLE*elongation);
        base[12] = new PVector(max(0, retrait0)*DIAG_RETRAIT,    max(0, retrait0)*DIAG_RETRAIT);
        base[13] = new PVector(magic*MAILLE*elongation/2F,       magic*MAILLE*elongation/2F);
        base[14] = new PVector(magic*MAILLE*elongation/2F,       MAILLE*elongation*(1F-magic/2F));
        base[15] = new PVector(max(0, retrait1)*DIAG_RETRAIT,    MAILLE*elongation-max(0, retrait1)*DIAG_RETRAIT);
        SignalNordOuest(       base[0].x,                        base[0].y,                   cible[0], 0);
        SignalNordEst(         base[1].x-MAILLE*(elongation-1),  base[1].y-MAILLE*elongation, cible[1], 0, 3);
        rotation_base(((orientation-2) % 8)/2, 0, 16);
    }
    //-------------------------------- calcule_point() ----------------------------------------------
    void calcule_points() {
        calcule_points_arc(MAILLE*elongation*HALF_PI/sqrt(2), base[0], base[13], base[14], base[1]);
        nb_points1 = nb_points;
    }
    Forme copy() { return new Arc90NordOuestSudOuest(); }
}
//***************************************************************************************************************************************************************************
class FlexibleSgauche extends Forme {
    FlexibleSgauche() {
        longueur_voie =  1;
        hauteur_voie  = -1;
        deformation   = MAILLE;
        courbe        = 4;
        description_forme();
    }
    //-------------------------------- description_forme() ------------------------------------------
    void description_forme() {       
        CalculFlexibleSgauche(longueur_voie, hauteur_voie, deformation);
        calcule_flexible(MAILLE/2F, RETRAIT, 0, 1);
    }
    Forme copy() { return new FlexibleSgauche(); }
}
//***************************************************************************************************************************************************************************
class FlexibleSgauche45 extends Forme {
    FlexibleSgauche45() {
        longueur_voie = 2;
        hauteur_voie  = 1;
        deformation   = MAILLE/2;
        courbe        = 4;
        description_forme();
    }
    //-------------------------------- description_forme() ------------------------------------------
    void description_forme() {       
        CalculFlexibleSgauche45(longueur_voie, hauteur_voie, deformation);
        calcule_flexible(0, DIAG_RETRAIT, DIAG_RETRAIT, 2);
    }
    Forme copy() { return new FlexibleSgauche45(); }
}
//***************************************************************************************************************************************************************************
class FlexibleSdroit extends Forme {
    FlexibleSdroit() {
        longueur_voie = 1;
        hauteur_voie  = 1;
        deformation   = 0;
        courbe        = 4;
        description_forme();
    }
    //-------------------------------- description_forme() ------------------------------------------
    void description_forme() {       
        CalculFlexibleSdroit(longueur_voie, hauteur_voie, deformation);
        calcule_flexible(MAILLE/2F, RETRAIT, 0, 1);
    }
    Forme copy() { return new FlexibleSdroit(); }
}
//***************************************************************************************************************************************************************************
class FlexibleSdroit45 extends Forme {
    FlexibleSdroit45() {
        longueur_voie = 1;
        hauteur_voie  = 2;
        deformation   = MAILLE/2;
        courbe        = 4;
        description_forme();
    }
    //-------------------------------- description_forme() ------------------------------------------
    void description_forme() {       
        CalculFlexibleSdroit45(longueur_voie, hauteur_voie, deformation);
        calcule_flexible(0, DIAG_RETRAIT, DIAG_RETRAIT, 2);
    }
    Forme copy() { return new FlexibleSdroit45(); }
}
//***************************************************************************************************************************************************************************
class Fosse extends Forme {
    Fosse() {
        elongation = 2*MAILLE;
        dessine_forme_fosse(FOSSE);
    }
    //--------------------------------modification_pont() ------------------------------------------
    void modification_fosse(int _elongation) {
        elongation  = _elongation;
        dessine_forme_fosse(FOSSE);
    }    
    //------------------------------------- dessine_forme_fosse() ---------------------------------------
    void dessine_forme_fosse(int _couleur_fosse) {
        noStroke();
        fill(NOIR);
        ellipse(MAILLE/2F, MAILLE/2F, elongation,    elongation);
        fill(_couleur_fosse);
        ellipse(MAILLE/2F, MAILLE/2F, elongation-3,  elongation-3);
        fill(NOIR);
        ellipse(MAILLE/2F, MAILLE/2F, elongation-10, elongation-10);
        fill(_couleur_fosse);
        ellipse(MAILLE/2F, MAILLE/2F, elongation-13, elongation-13);
        noFill();
    }
    Forme copy() {
        return new Fosse();
    }
}
//***************************************************************************************************************************************************************************
class Pont extends Forme {
    Pont() {
        description_forme();
    }
    //--------------------------------modification_pont() ------------------------------------------
    void modification_pont(int _elongation) {
        elongation  = _elongation;
        description_forme();
    }    
    //--------------------------------description_forme() ------------------------------------------
    void description_forme() {
        pont = createShape();
        float alpha1  = -2.961F;
        float alpha2  = -0.314F;
        float alpha3  = -0.609F;
        float alpha4  = -0.703F;
        float alpha5  = -0.801F;
        float alpha6  = -0.435F;
        float alpha7  = -6.103F;
        float alpha8  = -3.412F;
        float alpha9  = -3.548F;
        float alpha10 = -3.489F;
        float alpha11 = -3.549F;
        float alpha12 = -3.480F;        
        
        float x1_x  = MAILLE*elongation*cos(alpha1+theta);
        float x1_y  = MAILLE*elongation*sin(alpha1+theta);
        float x2_x  = MAILLE*elongation*cos(alpha12+theta);
        float x2_y  = MAILLE*elongation*sin(alpha12+theta);
        float magic1 = magic(x1_x, x1_y, x2_x, x2_y, MAILLE/2F, MAILLE/2F)*(MAILLE*(elongation-1));
        float p1_x  = x1_x-magic1*sin(0.177F+theta);
        float p1_y  = x1_y+magic1*cos(0.177F+theta);
        float p2_x  = x2_x-magic1*sin(0.353F-theta);
        float p2_y  = x2_y-magic1*cos(0.353F-theta);
        
        float x3_x  = MAILLE*elongation*cos(theta);
        float x3_y  = MAILLE*elongation*sin(theta);
        float x4_x  = MAILLE*elongation*cos(alpha7+theta);
        float x4_y  = MAILLE*elongation*sin(alpha7+theta);
        float magic2 = -magic(x3_x, x3_y, x4_x, x4_y, MAILLE/2F, MAILLE/2F)*(MAILLE*(elongation-1));
        float p3_x  = x3_x+magic2*sin(-theta);
        float p3_y  = x3_y+magic2*cos(-theta);
        float p4_x  = x4_x+magic2*sin(0.220F+theta);
        float p4_y  = x4_y-magic2*cos(0.220F+theta);

        pont.beginShape();
        pont.fill(PONT);
        pont.stroke(NOIR);
        pont.strokeWeight(1);
        pont.vertex       (x1_x+MAILLE/2F,                                         x1_y+MAILLE/2F                                       );  //  1
        pont.vertex       (MAILLE*elongation*0.578F*cos(alpha2+theta)+MAILLE/2F,   MAILLE*elongation*0.578F*sin(alpha2+theta)+MAILLE/2F );  //  2
        pont.vertex       (MAILLE*elongation*0.670F*cos(alpha3+theta)+MAILLE/2F,   MAILLE*elongation*0.670F*sin(alpha3+theta)+MAILLE/2F );  //  3
        pont.vertex       (MAILLE*elongation*0.593F*cos(alpha4+theta)+MAILLE/2F,   MAILLE*elongation*0.593F*sin(alpha4+theta)+MAILLE/2F );  //  4
        pont.vertex       (MAILLE*elongation*0.650F*cos(alpha5+theta)+MAILLE/2F,   MAILLE*elongation*0.650F*sin(alpha5+theta)+MAILLE/2F );  //  5
        pont.vertex       (MAILLE*elongation*1.106F*cos(alpha6+theta)+MAILLE/2F,   MAILLE*elongation*1.106F*sin(alpha6+theta)+MAILLE/2F );  //  6
        pont.vertex       (x3_x+MAILLE/2F,                                         x3_y+MAILLE/2F                                       );  //  7
        pont.bezierVertex (p3_x+MAILLE/2F, p3_y+MAILLE/2F, p4_x+MAILLE/2F,         p4_y+MAILLE/2F, x4_x+MAILLE/2F, x4_y+MAILLE/2F);
        pont.vertex       (MAILLE*elongation*0.670F*cos(alpha8+theta)+MAILLE/2F,   MAILLE*elongation*0.670F*sin(alpha8+theta)+MAILLE/2F );  //  8
        pont.vertex       (MAILLE*elongation*0.703F*cos(alpha9+theta)+MAILLE/2F,   MAILLE*elongation*0.703F*sin(alpha9+theta)+MAILLE/2F );  //  9
        pont.vertex       (MAILLE*elongation*0.817F*cos(alpha10+theta)+MAILLE/2F,  MAILLE*elongation*0.817F*sin(alpha10+theta)+MAILLE/2F);  // 10
        pont.vertex       (MAILLE*elongation*0.837F*cos(alpha11+theta)+MAILLE/2F,  MAILLE*elongation*0.837F*sin(alpha11+theta)+MAILLE/2F);  // 11
        pont.vertex       (x2_x+MAILLE/2F,                                         x2_y+MAILLE/2F                                       );  // 12
        pont.bezierVertex (p2_x+MAILLE/2F, p2_y+MAILLE/2F, p1_x+MAILLE/2F,         p1_y+MAILLE/2F, x1_x+MAILLE/2F, x1_y+MAILLE/2F);
        pont.endShape(CLOSE);
    }
    //--------------------------------------- dessine_forme_pont_palette() -----------------------------------------------
    void dessine_forme_pont_palette(int _couleur, int _c, int _l) {
        pont.setFill(_couleur);
        shape(pont, 0, 0);
    }
    //--------------------------------------- dessine_forme_pont() -----------------------------------------------
    void dessine_forme_pont(int _couleur) {
        pushMatrix();
            pont.setFill(_couleur);
            translate(MAILLE/2F, MAILLE/2F);
            scale(0.05F, 0.05F);
            shape(pont, -MAILLE/2F, -MAILLE/2F);
        popMatrix();
    }
    Forme copy() {
        return new Pont();
    }
}
//***************************************************************************************************************************************************************************
class RailsPont extends Forme {
    float elongation = 0F;
    RailsPont() {
        description_forme();
    }
    //--------------------------------modification_pont() ------------------------------------------
    void modification_pont(int _elongation) {
        elongation  = _elongation/2F;
        description_forme();
        points.clear();
        calcule_points();
    }    
    //--------------------------------description_forme() ------------------------------------------
    void description_forme() {       
        float alpha1 = atan(RAIL/64F/MAILLE/elongation);
        base[0]  = new PVector(MAILLE*elongation*cos(PI-alpha1+theta)+MAILLE/2F, MAILLE*elongation*sin(PI-alpha1+theta)+MAILLE/2F);
        base[1]  = new PVector(MAILLE*elongation*cos(alpha1+theta)+MAILLE/2F,    MAILLE*elongation*sin(alpha1+theta)+MAILLE/2F);
        base[12] = new PVector(base[0].x,                                        base[0].y);
        base[13] = new PVector(base[1].x,                                        base[1].y);
        SignalOuest(           base[0].x,                                        base[0].y,         cible[0], 0);
        SignalEst(            -base[1].x+MAILLE,                                -base[1].y+MAILLE,  cible[1], 0, 2);
    }
    //--------------------------------calcule_point() ----------------------------------------------
    void calcule_points() {
        calcule_points_droite(base[0], base[1]);
        nb_points1 = nb_points;
    }
    Forme copy() { return new RailsPont(); }
}
//***************************************************************************************************************************************************************************
class VoiePont extends Forme {
    int ordre               = 0;
    VoiePont() {
        courbe              = 0;
        c_voie_pont         = 0;
        l_voie_pont         = 0;
        longueur_voie       = 0;
        hauteur_voie        = 0;
        deformation         = 1;
        description_forme();
    }
    //--------------------------------modification_voie_pont() ------------------------------------------
    void modification_voie_pont(int _c_voie_pont, int _l_voie_pont, int _longueur_voie, int _hauteur_voie, int _deformation, int _ordre) {
        c_voie_pont   = _c_voie_pont;
        l_voie_pont   = _l_voie_pont;
        longueur_voie = _longueur_voie;
        hauteur_voie  = _hauteur_voie;
        deformation   = _deformation;
        ordre         = _ordre;
        description_forme();
        calcule_points();
    }
    //--------------------------------description_forme() ------------------------------------------
    void description_forme() {
        CalculVoiePont(c_voie_pont, l_voie_pont, deformation, longueur_voie, hauteur_voie);
        base[0]  = new PVector(X3_x,  X3_y);
        base[1]  = new PVector(X4_x,  X4_y);
        if (voie_pont_droite) {
            courbe = 0;
            base[12] = new PVector(X3_x,  X3_y);
            base[13] = new PVector(X4_x,  X4_y);
        } else {
            if (longueur_voie == 0) {
                courbe = 6;
                base[12] = new PVector(X3_x,  X3_y);
                base[13] = new PVector(X4_x,  X4_y);
                base[14] = new PVector(P1_x,  P1_y);
            } else {
                courbe = 5;
                base[12] = new PVector(X3_x,  X3_y);
                base[14] = new PVector(T3_x,  T3_y);
                base[15] = new PVector(P3_x,  P3_y);
                base[16] = new PVector(P4_x,  P4_y);
                base[17] = new PVector(T4_x,  T4_y);
                base[13] = new PVector(X4_x,  X4_y);
            }
        }
    }
    //--------------------------------calcule_point() ----------------------------------------------
    void calcule_points() {
        nb_points1 = 0;
        nb_points2 = 0;
        nb_points3 = 0;
        points.clear();
        if (longueur_voie == 0 || voie_pont_droite) {
            calcule_points_droite(base[12], base[13]);
            nb_points1 = nb_points;
        } else {
            calcule_points_droite(base[12], base[14]);
            nb_points1 = nb_points;
            calcule_points_arc(R4*alpha4, base[14], base[15], base[16], base[17]);
            nb_points2 = nb_points;
            calcule_points_droite(base[17], base[13]);
            nb_points3 = nb_points;
        }
    }
    Forme copy() {
        return new VoiePont();
    }
}
//***************************************************************************************************************************************************************************
class NullForme extends Forme { 
    NullForme()  {  }
    Forme copy() { return new NullForme(); }
}
