//--------------------------- tco ------------------------------
final int CURSEUR        = 15;                //  dimension du curseur dans les ascenseurs H et V
final int ACCELERATION   = 10;                //  pour n'afficher le reseau moins souvent
final int DECALAGE_X     = 72;                //  curseur depart : decalage en x du centre de la cible par rapport au coin superieur gauche
final int DECALAGE_Y     = 47;                //  curseur depart : decalage en y du centre de la cible par rapport au coin superieur gauche

int       MAILLE         = 10;                //  maille de la grille
float     RAIL           = 2F;                //  largeur des rails dans un pavé
float     DIAG_RAIL      = RAIL/sqrt(2F)/2F;  //  demie diagonale de RAIL/2
int       BORDURE_X      = 10;
int       BORDURE_Y      = 10;
int       C_MAX          = 188;               //  nombre de colonnes maxi
int       L_MAX          = 104;               //  nombre de lignes maxi
int       ZOOM_INIT      = 8;                 //  zoom au demarrage

float     RETRAIT        = 1;                 //  largeur d'un 1/2 retrait 
float     DIAG_RETRAIT   = RETRAIT/sqrt(2F);  //  diagonale de RETRAIT
float     TAILLE_FEU     = MAILLE/6F;         //  taille du feu

float     EPAISSEUR_MAT  = 0.4F;              //  epaisseur du mat de la cible
float     LONGUEUR_MINI  = 5F*MAILLE;         //  longueur mini pour qu'une zone ait des cibles
float     PAS            = 0.5F;              //  "pas" entre deux points

int       INDEX_MAX      = 200;               //  nombre maximum de pavés dans un itineraire
int       MAX_A_B        = 40;                //  nombre maximum d'itineraires pour A et B donnes

//-------------------- java : file name --------------------------
//  utilise pour sélectionner les fichiers
import java.io.*;
 
FilenameFilter tsvFilter = new FilenameFilter() {
    public boolean accept(File dir, String name) {
        return name.toLowerCase().endsWith(".tsv");
    }
};

//------------------------ fileSelected() ------------------------------
void fileSelected(File selection) {
    if (selection != null) {
        file_selected = selection.getAbsolutePath();
        charge_table_TCO();
    } else {
        one_shot            = true;
        deplacement_palette = false;
        width_precedent     = width;
        tables_construites  = true;
    }
}

//---------------------- java : JOptionPlane -------------------------
//  utilise pour les questions
import static javax.swing.JOptionPane.*;
//---------------------------------------------- couleurs ------------------------------
int       GRIS       = #808080;
int       ROUGE      = #FF0000;
int       GRIS_FONCE = #B5B5B5;
int       BLANC      = #FFFFFF;
int       JAUNE      = #FFFF00;
int       VERT       = #00FF00;
int       VIOLET     = #FA439F;
int       VERT_FONCE = #008000;
int       ARDOISE    = #2A292A;
int       BLEU       = #0000FF;
int       BLEU1      = #C8E8E8;
int       BLEU2      = #9AB3B3;
int       FOSSE      = #6E696A;
int       PONT       = #A6A6A6;
int       FOND       = #636363;
int       NOIR       = #000000;
int       AQUA       = #00FFFF;
int       OR         = #FFD900;
int       OLIVE      = #556B2F;
int       SABLE      = #F4A460;
int       POURPRE    = #BA55D3;
int       VERT_FLUO  = #7CFC00;


////////////////////////////////////////////////////////////////////////////////////////////////////
//--------------------------- TCO ------------------------------    
int       zoom_x = ZOOM_INIT;
int       zoom_y = ZOOM_INIT;
boolean   one_shot            = true;
//boolean   one_shot_palette    = true;
float     c_min               = 0F;      //  draw from colonne c_min
float     l_min               = 0F;      //  draw from ligne l_min
float     zoom_change         = 0;      //  zoom change when mousewheel or +/-
int       niveau              = 1;      //  niveau of the layout
int       l_start             = 0;
int       l_stop              = 0;
int       width_precedent     = 0;
boolean   cliFeux;                            // pour clignotement feux
//------------------------- variables spéciales pupitre -------------------
int       zoom_pupitre        = 0;
int       x_pupitre           = 0;
int       y_pupitre           = 0;
//-------------------------- positions ----------------------------------
int       bordure_x           = 0;      //  border out of the grid of the TCO in x
int       bordure_y           = 0;      //  border out of the grid of the TCO in y
int       xOffset             = 0;      //  
int       yOffset             = 0;
int       x_precedent         = 0;
int       y_precedent         = 0;
int       x_mouse             = 0;
int       y_mouse             = 0;
int       c_mouse             = 0;
int       l_mouse             = 0;
int       c_info_pave         = 0;
int       l_info_pave         = 0;
int       longueur_avant      = 0;
int       hauteur_avant       = 0;
float     X_m                 = 0F;
float     Y_m                 = 0F;
int       c_depart            = 0;
int       l_depart            = 0;
int       c_arrivee           = 0;
int       l_arrivee           = 0;
int       c_retour            = 0;
int       l_retour            = 0;
int       c_autre             = 0;
int       l_autre             = 0;
boolean   trouve              = false;
int       c_trouve            = 0;
int       l_trouve            = 0;
PVector   depart, arrivee, connecteur_courant, autre, connecteur_retour;
//----------------------- load/save --------------
String    file_selected;
String    begin;
String    date;
//--------------------- palette ------------------
int       x_palette           = 0;      //  position x of the palette
int       y_palette           = 0;      //  position y of the palette
int       x_mouse_p           = 0;      //  position x of the mouse in the palette
int       y_mouse_p           = 0;      //  position y of the mouse in the palette
int       x_offset_p          = 0;      //  decalage de la position X de la souris quand on prend la palette
int       y_offset_p          = 0;      //  decalage de la position Y de la souris quand on prend la palette
String    numero_de_zone      = "";     //  numero de la zone survolee par la souris

//-------------------- booleans for keys -----------------------
boolean   affiche_grille      = true;   //  affiche la grille ou pas
boolean   affiche_coordonnees = false;  //  avec les coordonnees
boolean   affiche_palette     = true;   //  affiche la palette ou pas
boolean   mode_selection      = false;  //  passe en mode sélection
boolean   deplacement         = false;  //  déplacement des pavés
boolean   nettoyage           = false;  //  nettoie les zones sélectionnées
boolean   nettoyage_effectue  = false;
boolean   etiquettes_pont     = false;  //  affiche les étiquettes du pont tournant
boolean   mode_flexible       = false;  //  mode flexible
boolean   deplacement_palette = false;  //  déplacement de la palette
boolean   itineraire_demande  = false;  //  demande d'itinéraire
boolean   montre_itineraires  = false;  //  montre tous les itineraires
int       position_bouton     = 0;
int       position_pave       = 0;
boolean   aide                = false;
boolean   sauve               = false;
boolean   affiche_numero_zone = false;
boolean   zone_noire          = false;
boolean   affiche_points      = false;
boolean   tables_construites  = false;
boolean   affiche_origine     = false;
boolean   passe_one_shot      = false;
//------------------------------ background -----------------------
PImage    fond_pave;                    //  200x200
PImage    fond_bouton[]       = new PImage[30];                  //  200x200
PImage    fond_menu;                    //  200x200
PImage    ombre_bouton[]      = new PImage[30];
int       fond_pave_width     = 200;
int       fond_pave_height    = 200;
PImage    curseur_depart;
PImage    curseur_arrivee;
PImage    curseur_montre_itineraires;
PImage    curseur_zone;
PImage    ecran;
PImage    fond_ecran;
//----------------------------- couleurs des curseurs-------------------------------
color couleur_bords           = color(0,0,0);
color couleur_fond_barre      = FOND;
color couleur_curseur         = GRIS;
color couleur_au_dessus_barre = BLEU2;
color couleur_curseur_presse  = BLEU1;
int       largeur             = width -CURSEUR;
int       hauteur             = height-CURSEUR;

//--------------------------------- Pont tournant --------------------------------------------
int[]     Pont              = new int[162];          //  Pont
float     theta               = 0F;
int       max_ordre           = 0;
float     c0_pont             = 0F;
float     l0_pont             = 0F;
boolean   pont_tournant_pose        = false;
boolean   voie_pont_tournant_posee   = false;
int       pont_compte_voies  = 0;
boolean   voie_pont_droite = false;

Table     TCO;
Zone      zone_traitee;
//-------------------------------- recherche d'un itineraire ------------------------------------
int       index               = 0;
int[][]   iti                 = new int[INDEX_MAX][5];    //  INDEX_MAX lignes et c, l, rang (0, 1, 2), lames (0, 1, 2, 3) & multi de premier (1, 2, 3)
PVector[] premier             = new PVector[INDEX_MAX];
PVector   sortie              = new PVector();
boolean   retour              = false;
boolean   fini                = false;
int       courant             = 0;
int       nb_itineraires      = 0;
int       numero_iti          = 0;
boolean   rien_trouve         = false;
boolean   cherche_arrivee     = false;
int       compteur            = 0;
int       tout_premier        = 0;
//--------------------------------- cibles ----------------------------------------------------
String    zone_courante       = "-";
int       connecteur_futur    = 0;
int       vitesse_maxi        = 0;

//--------------------------------- images -------------------------
PImage    texte_aide;
int       largeur_texte       = 0;
int       hauteur_texte       = 0;

PFont f;
//-------------------------- feux ------------------------------
final int ETEINT                    = 0;
final int VOIE_LIBRE                = 1;
final int AVERTISSEMENT             = 2;
final int SEMAPHORE                 = 3;
final int SEMAPHORE_CLI             = 4;
final int CARRE                     = 5;
final int MANOEUVRE                 = 6;
final int CARRE_VIOLET              = 7;
final int RALENTISSEMENT            = 8;
final int RALENTISSEMENT_CLI        = 9;
final int RAPPEL_RALENTISSEMENT     = 10;
final int RAPPEL_RALENTISSEMENT_CLI = 11;
final int COMBINE                   = 12;
final int COMBINE_CLI               = 13;
final int BUTOIR                    = 14;
final int DISQUE                    = 15;

//------------------ charge_images() ------------------------
void charge_images() {
    fond_bouton[0]   = loadImage("data/Icones/Selection.png");
    ombre_bouton[0]  = loadImage("data/Icones/Selection inverse.png");
    fond_bouton[1]   = loadImage("data/Icones/Deplacement.png");
    ombre_bouton[1]  = loadImage("data/Icones/Deplacement inverse.png");
    fond_bouton[2]   = loadImage("data/Icones/Efface.png");
    ombre_bouton[2]  = loadImage("data/Icones/Efface inverse.png");
    fond_bouton[3]   = loadImage("data/Icones/Tourne plus.png");
    ombre_bouton[3]  = loadImage("data/Icones/Tourne plus inverse.png");
    fond_bouton[4]   = loadImage("data/Icones/Tourne moins.png");
    ombre_bouton[4]  = loadImage("data/Icones/Tourne moins inverse.png");
    fond_bouton[5]   = loadImage("data/Icones/Zoom plus.png");
    ombre_bouton[5]  = loadImage("data/Icones/Zoom inverse.png");
    fond_bouton[6]   = loadImage("data/Icones/Zoom moins.png");
    ombre_bouton[6]  = loadImage("data/Icones/Zoom inverse.png");
    fond_bouton[7]   = loadImage("data/Icones/Palette.png");
    ombre_bouton[7]  = loadImage("data/Icones/Palette inverse.png");
    fond_bouton[8]   = loadImage("data/Icones/Niveau.png");
    ombre_bouton[8]  = loadImage("data/Icones/Niveau inverse.png");
    fond_bouton[9]   = loadImage("data/Icones/Grille.png");
    ombre_bouton[9]  = loadImage("data/Icones/Grille inverse.png");
    fond_bouton[10]  = loadImage("data/Icones/Fichier.png");
    ombre_bouton[10] = loadImage("data/Icones/Fichier inverse.png");
    fond_bouton[11]  = loadImage("data/Icones/Sauve.png");
    ombre_bouton[11] = loadImage("data/Icones/Sauve inverse.png");
    fond_bouton[12]  = loadImage("data/Icones/Zone.png");
    ombre_bouton[12] = loadImage("data/Icones/Zone inverse.png");
    fond_bouton[13]  = loadImage("data/Icones/Points.png");
    ombre_bouton[13] = loadImage("data/Icones/Points inverse.png");
    fond_bouton[14]  = loadImage("data/Icones/Analyse.png");
    ombre_bouton[14] = loadImage("data/Icones/Analyse inverse.png");
    fond_bouton[15]  = loadImage("data/Icones/Aide.png");
    ombre_bouton[15] = loadImage("data/Icones/Aide inverse.png");
    fond_ecran       = loadImage("data/Icones/Fond ecran.png");
    //------------------------ Images --------------------------------------------------
    fond_pave        = loadImage("data/Icones/Carre.jpg");
}
//--------------------------- left points -----------------------
float     X1_x   = 0F;
float     X1_y   = 0F;
float     X3_x   = 0F;
float     X3_y   = 0F;
float     X5_x   = 0F;
float     X5_y   = 0F;
//--------------------------- right points ----------------------
float     X2_x   = 0F;
float     X2_y   = 0F;
float     X4_x   = 0F;
float     X4_y   = 0F;
float     X6_x   = 0F;
float     X6_y   = 0F;
//--------------------------- left arc points -----------------------
float     X_1_x  = 0F;
float     X_1_y  = 0F;
float     X_3_x  = 0F;
float     X_3_y  = 0F;
float     X_5_x  = 0F;
float     X_5_y  = 0F;
//--------------------------- right arc points ----------------------
float     X_2_x  = 0F;
float     X_2_y  = 0F;
float     X_4_x  = 0F;
float     X_4_y  = 0F;
float     X_6_x  = 0F;
float     X_6_y  = 0F;
//--------------------------- tangent points -----------------------
float     T1_x   = 0F;
float     T1_y   = 0F;
float     T3_x   = 0F;
float     T3_y   = 0F;
float     T5_x   = 0F;
float     T5_y   = 0F;
//--------------------------- tangent points ----------------------
float     T2_x   = 0F;
float     T2_y   = 0F;
float     T4_x   = 0F;
float     T4_y   = 0F;
float     T6_x   = 0F;
float     T6_y   = 0F;
//----------------------- left centers ---------------------------
float     C1_x   = 0F;
float     C1_y   = 0F;
float     C3_x   = 0F;
float     C3_y   = 0F;
float     C5_x   = 0F;
float     C5_y   = 0F;
//---------------------- right centers ----------------------------
float     C2_x   = 0F;
float     C2_y   = 0F;
float     C4_x   = 0F;
float     C4_y   = 0F;
float     C6_x   = 0F;
float     C6_y   = 0F;
//---------------------- right radius -----------------------------
float     R1     = 0F;
float     R3     = 0F;
float     R5     = 0F;
//---------------------- left radius ------------------------------
float     R2     = 0F;
float     R4     = 0F;
float     R6     = 0F;
//----------------------- left angle -------------------------------------
float     alpha0 = 0F;
float     alpha1 = 0F;
float     alpha3 = 0F;
float     alpha5 = 0F;
//------------------------ rignt angle -------------------------------------
float     alpha2 = 0F;
float     alpha4 = 0F;
float     alpha6 = 0F;
//-------------------------- left magic points ----------------------------------
float     P1_x   = 0F;
float     P1_y   = 0F;
float     P3_x   = 0F;
float     P3_y   = 0F;
float     P5_x   = 0F;
float     P5_y   = 0F;
//--------------------------right magic points -----------------------------------
float     P2_x   = 0F;
float     P2_y   = 0F;
float     P4_x   = 0F;
float     P4_y   = 0F;
float     P6_x   = 0F;
float     P6_y   = 0F;
//---------------------------- left meddle magic points --------------------------
float     P1g_x  = 0F;
float     P1g_y  = 0F;
float     P3g_x  = 0F;
float     P3g_y  = 0F;
float     P5g_x  = 0F;
float     P5g_y  = 0F;
//---------------------------- right meddle magic points ----------------------------
float     P2d_x  = 0F;
float     P2d_y  = 0F;
float     P4d_x  = 0F;
float     P4d_y  = 0F;
float     P6d_x  = 0F;
float     P6d_y  = 0F;
//---------------------------- magic point -------------------------------------
float     k      = 0F;
float     Q1_x   = 0F;
float     Q1_y   = 0F;
float     Q2_x   = 0F;
float     Q2_y   = 0F;
